<?php
namespace Teknisa\GOP\Services;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\Session\Session;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;


class ControllerWrapper{

    protected $controller;

    public function __construct(TeknisaCrud $controller){
        $this->controller = $controller;
    }

    //para compatibilidade
    public function find(FilterCriteria $filterCriteria){
        return $this->getDataSets($filterCriteria);
    }

    public function getDataSets(FilterCriteria $filterCriteria){
        $request = new DTO\Request\Filter($filterCriteria, '', '', '');
        $response = new DTO\Response();
        $this->controller->find($request, $response);
        $datasets = $response->getDataSets();
        return $datasets;
    }

    public function getRows(FilterCriteria $filterCriteria, $dataSetNumber=0){
        $datasets=$this->getDataSets($filterCriteria);
        return $datasets[$dataSetNumber]->getRows();
    }

    public static function fetchFromController($controller, FilterCriteria $filterCriteria){
        $request = new DTO\Request\Filter($filterCriteria, '', '', '');
        $response = new DTO\Response();
        $controller->find($request, $response);
        $datasets = $response->getDataSets();
        return $datasets[0]->getRows();
    }
}