<?php
namespace Teknisa\GOP\Services;

 use Zeedhi\Framework\DataSource\DataSet;
 use Zeedhi\Framework\DTO;
 
 class Gop10001SimulacaoValoresService {
    protected $connection;
    
    public function __construct($connection, $environment){
        $this->connection = $connection;
        $this->environment = $environment;
    }
     
    public function verifyParamVrFaturamento($row) {
        $select = "SELECT F.*, (SELECT
                        CASE NVL(MAX(IDCALCPERCENTFAT), 'FATURAMENTOLIQUIDO')
                            WHEN 'FATURAMENTO_BRUTO' THEN
                                'FATURAMENTO'
                            ELSE
                                'FATURAMENTOLIQUIDO'
                        END IDCALCPERCENTFAT
                    FROM
                        PARFILIALROP P
                    WHERE
                        P.CDFILIAL = TIPOPARAM_DRO(CDFILIAL)) VRFATURAMENTO FROM FILIAL F";
        
        $params = array (
            "P_CDFILIAL" => $row["CDFILIAL"]
        );
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]['IDCALCPERCENTFAT'];
        }catch (Exception $e){
            throw $e;
        }  
    } 
    
    public function getDataNotExistsBkpFatCons($list, $paramsSimulation) {
        $select = "SELECT
                        O.CDFILIAL,
                        D.CDSERVFILI,
                        D.CDPRODUTO,
                        NVL(D.QTORCAMENTO, 0) QTORCAMENTO,
                        NVL(D.QTORCAMENTO, 0) QTESTIMADA,
                        NVL(D.VRPRECOBASE, 0) VRPRECOBASE,
                        NVL(D.VRORCAMENTO, 0) VRORCAMENTO,
                        M.DTORCAMENTO NRMES,
                        DECODE(D.QTORCAMENTO, 0, 0,(NVL(D.VRORCAMENTO, 0) / D.QTORCAMENTO)) CUSTPERCAPITA,
                        I.IDTIPOORCAOP
                    FROM
                        ORCAMENTOGOP        O
                        INNER JOIN ITEMORCAGOP         I ON I.NRORCAMENTOGOP = O.NRORCAMENTOGOP
                        INNER JOIN ITORCAMESGOP        M ON M.NRITEMORCAOP = I.NRITEMORCAOP
                        INNER JOIN ITDETALORCAMESGOP   D ON D.NRITORCAMESGOP = M.NRITORCAMESGOP
                        LEFT JOIN LISTA                L ON L.NRLISTA = :P_NRLISTA
                                                        AND L.CDLISTA = (O.CDFILIAL || I.IDTIPOORCAOP || NVL(D.CDSERVFILI, D.CDPRODUTO))
                    WHERE
                        O.NRANOORCAGOP = :P_ANO
                        AND O.IDPERIODOORCA = :P_IDPERIODOORCA
                        AND O.NRPERIODOORCA = :P_NRPERIODOORCA
                        AND O.NRORG = :P_NRORG
                        AND I.IDTIPOORCAOP IN ('FATURAMENTO', 'CONSUMO')
                        AND L.CDLISTA IS NULL
                    ORDER BY
                        O.CDFILIAL,
                        M.DTORCAMENTO"; 
                    
        $params = array(
            ":P_NRLISTA" => $list,
            ":P_ANO" => $paramsSimulation["P_ANO"],
            ":P_IDPERIODOORCA" => $paramsSimulation["P_IDPERIODOORCA"],
            ":P_NRPERIODOORCA" => $paramsSimulation["P_NRPERIODOORCA"],
            ":P_NRORG"=> $this->environment->getNrOrg()
        );
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
            
            return $result;
        }catch(Exception $e){
            throw $e;
        }
    }
    
    public function getDataNotExistsBkpMaoObra($list, $paramsSimulation) {
        $select = "SELECT
                        O.CDFILIAL,
                        I.CDORCAMENTOMO,
                        D.CDDESPADMFAT,
                        NVL(M.VRORCAMENTO, 0) VRORCAMENTO,
                        M.DTORCAMENTO NRMES,
                        I.IDTIPOORCAOP
                    FROM
                        ORCAMENTOGOP        O
                        INNER JOIN ITEMORCAGOP         I ON I.NRORCAMENTOGOP = O.NRORCAMENTOGOP
                        INNER JOIN ITORCAMESGOP        M ON M.NRITEMORCAOP = I.NRITEMORCAOP
                        INNER JOIN ITDETALORCAMESGOP   D ON M.NRITORCAMESGOP = D.NRITORCAMESGOP
                        LEFT JOIN LISTA               L ON L.NRLISTA = :P_NRLISTA || I.IDTIPOORCAOP || O.CDFILIAL || I.CDORCAMENTOMO || D.CDDESPADMFAT )
                    WHERE
                        O.NRANOORCAGOP = :P_ANO
                        AND O.IDPERIODOORCA = :P_IDPERIODOORCA
                        AND O.NRPERIODOORCA = :P_NRPERIODOORCA
                        AND O.NRORG = :P_NRORG
                        AND I.IDTIPOORCAOP = 'MAOOBRA'
                        AND L.CDLISTA IS NULL
                    ORDER BY
                        O.CDFILIAL,
                        M.DTORCAMENTO";
        
        $params = array (
            ":P_NRLISTA" => $list,
            ":P_ANO" => $paramsSimulation["P_ANO"],
            ":P_IDPERIODOORCA" => $paramsSimulation["P_IDPERIODOORCA"],
            ":P_NRPERIODOORCA" => $paramsSimulation["P_NRPERIODOORCA"],
            ":P_NRORG" => $this->environment->getNrOrg()
        );
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
           
            return $result;
        }catch(Exception $e){
            throw $e;
        }
    }
    
    public function getDataNotExistsBkpDetail($list, $paramsSimulation) {
        $select = "SELECT
                        O.CDFILIAL,
                        NVL(I.CDINVEST, NVL(I.CDIMPOSTO, I.CDDESPPREV)) CODIGO,
                        I.CDINVEST,
                        I.CDIMPOSTO,
                        I.CDDESPPREV,
                        M.VRPERCENTUAL,
                        NVL(M.VRORCAMENTO, 0) VRORCAMENTO,
                        M.DTORCAMENTO NRMES,
                        IDTIPOORCAOP
                    FROM
                        ORCAMENTOGOP   O
                        INNER JOIN ITEMORCAGOP    I ON I.NRORCAMENTOGOP = O.NRORCAMENTOGOP
                        INNER JOIN ITORCAMESGOP   M ON M.NRITEMORCAOP = I.NRITEMORCAOP
                        LEFT JOIN LISTA           L ON L.NRLISTA = :P_NRLISTA
                                                    AND L.CDLISTA = (O.CDFILIAL || I.IDTIPOORCAOP || NVL(I.CDINVEST, NVL(I.CDIMPOSTO, I.CDDESPPREV)))
                    WHERE
                        O.NRANOORCAGOP = :P_ANO
                        AND O.IDPERIODOORCA = :P_IDPERIODOORCA
                        AND O.NRPERIODOORCA = :P_NRPERIODOORCA
                        AND O.NRORG = :P_NRORG
                        AND I.IDTIPOORCAOP IN ('INVESTIMENTO', 'IMPOSTO', 'DESPMATRIZ', 'DESPDIVERSA', 'DESPENTRADA', 'IMPOSTOARECUPERAR', 'IMPOSTOSOBLUCRO', 'TAXAADM', 'INVESTIMENTO', 'DEPRECIACAO')
                        AND L.CDLISTA IS NULL
                    ORDER BY
                        O.CDFILIAL,
                        M.DTORCAMENTO";
                        
        $params = array(
            ":P_NRLISTA" => $list,
            ":P_NRANOORCAGOP" => $paramsSimulation["P_ANO"],
            ":P_IDPERIODOORCA" => $paramsSimulation["P_IDPERIODOORCA"],
            ":P_NRPERIODOORCA" => $paramsSimulation["P_NRPERIODOORCA"],
            ":P_NROG" => $this->environment->getNrOrg()
        );
        
        try {
            $std = $this->connection->prepare($select);
            $std->execute($params);
            $result = $std->fetchAll();
           var_dump($result);
            return $result;
        }catch(Exception $e){
            throw $e;
        }
    }
 } 